import java.lang.*;
import java.util.*;

public class Mapy1
 { static HashSet <Dane1> hashset=new HashSet <Dane1>();
   static HashMap <Dane1,Dane1> hashmap=new HashMap<Dane1,Dane1>();
   static TreeMap <Dane1,Dane1> treemap=new TreeMap<Dane1,Dane1>();
   
   static public byte[] wypelnij(int n,int m,int offset,int zakres)
    { byte tablica1[]=new byte[n];
      Random r=new Random(m);
      for (int i=0; i<tablica1.length;i++) 
        tablica1[i]=(byte)(offset+r.nextInt(zakres));
        return tablica1;
    }
   
   static Dane1 Wstaw(int i)
    {    String nazwisko=new String(wypelnij(i+1,i+1,65,26));
         String uwagi=new String(wypelnij(2*i+1,2*i+1,65,26));
         String srednia=new String(wypelnij(1,i+1,48,6))+"."
                        + new String(wypelnij(2,3*i+1,48,10));
         return Dane1.Wstaw(nazwisko,uwagi,srednia);
     }
   
   static public void wypelnij1(int n, Collection<Dane1> kol)
    { for (int i=0; i<n;i++) 
       { kol.add(Wstaw(i)); }
     }
     
  static public void wypelnij2(int n, Map <Dane1,Dane1>mapa)
    { for (int i=0; i<n;i++) 
       { Dane1 dane=Wstaw(i);
         mapa.put(dane,dane);}
     }
  

 static <K, V> Map<K, V> sumamap(Map<K, V>pierwsza, 
                                Map<K, V> druga) 
 { Map<K, V> sumamap_ = new HashMap<K, V>(pierwsza);
   sumamap_.putAll(druga);
   return sumamap_;}


  static <K, V> Set<K>  walidacja(Map<K, V> podstawowa,
                                  Set<K> wzorzec) 
   {Set<K> zle = new TreeSet<K>(wzorzec);
    Set<K> klucze = podstawowa.keySet();
    if(!klucze.containsAll(wzorzec)) {
        zle.retainAll(klucze);          
    }  
    return zle;
}

 
  public static void main(String args[])
    { 
      wypelnij1(5,hashset);wypelnij1(5,hashset);
      wypelnij2(3,hashmap);wypelnij2(3,hashmap);
      wypelnij2(4,treemap);wypelnij2(4,treemap);
      
      System.out.println("hashmap\n"+hashmap.toString());
      System.out.println("treemap\n"+treemap.toString());        
      Dane1 a=Wstaw(2);
      a.uwagi="sss";
      boolean b1=hashmap.containsKey(a);
      System.out.println(b1+", ze znaleziono w HashMap klucz\n"+a);
      boolean b2=hashmap.containsValue(a);
      System.out.println(b2+", ze znaleziono w HashMap dane\n"+a);
      b1=treemap.containsKey(a);
      System.out.println(b1+", ze znaleziono w TreeMap klucz\n"+a);
      b2=treemap.containsValue(a);
      System.out.println(b2+", ze znaleziono w TreeMap dane\n"+a);
      Map <Dane1, Dane1> sumamap_ = sumamap(treemap,hashmap);
      System.out.println("suma map\n"+sumamap_.toString()); 
      
      System.out.println("hashset\n"+hashset.toString());
      Set <Dane1>klucze_walidacji=walidacja(treemap,hashset);
      System.out.println("wspolny zbior kluczy w treemap i hashset\n"+klucze_walidacji.toString());
      System.out.println("Wynik porownania zbioru kluczy w TreeMap i HashMap:"+treemap.keySet().equals(hashmap.keySet()));
     }
 }