import java.awt.*;
import java.lang.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import java.awt.event.*;
import javax.swing.table.*;


class Panel extends JPanel implements ListSelectionListener
{ JTable tabela;
  DefaultTableModel model; 
  Vector <Dane1> dane;
  int wiersz;
  
 public Panel(Vector <Dane1> v) 
 {super();
  dane=v;
  final String[] columnNames = {"Nazwisko","Uwagi","Srednia"};
  model=new DefaultTableModel(columnNames,0); 
  tabela= new JTable(model);
  model.addRow(new Vector<String>(3));
  tabela.setPreferredScrollableViewportSize(new Dimension(250,150));
  tabela.setSelectionMode(ListSelectionModel.SINGLE_SELECTION );
  ListSelectionModel selekcja = tabela.getSelectionModel();
  selekcja.addListSelectionListener(this); 
  JScrollPane suwak = new JScrollPane(tabela);
  add(suwak);
  }
       
  public void valueChanged(ListSelectionEvent e) 
   {
    if (e.getValueIsAdjusting()) return;
    ListSelectionModel lsm = (ListSelectionModel)e.getSource();
    if (!lsm.isSelectionEmpty())  
      {wiersz = lsm.getMinSelectionIndex();
       System.out.println("Wiersz " + wiersz+ " jest wybrany.");
      }
    }
  
  public void wyswietl()
  {  	
   	Iterator iterator = dane.iterator();
    model.setRowCount(0);
   	int i=0;
    while(iterator.hasNext())
       { Dane1 t=(Dane1)iterator.next(); 	
         Vector <String>vv=new Vector<String>(3);
         model.addRow(vv);        
         model.setValueAt(t.Podaj_nazwisko(),i,0);       
         model.setValueAt(t.Podaj_uwagi(),i,1); 
         model.setValueAt(""+t.Podaj_srednia(),i,2);
         i++;    
       }                                             
     Vector <String>vv=new Vector<String>(3); 
     model.addRow(vv); 
  }
  
  void obslugaactionPerformed()
   {if(tabela.isRowSelected(wiersz))
      {String nazwisko=(String)model.getValueAt(wiersz, 0); //pobranie z wybranych 
       String uwagi=(String)model.getValueAt(wiersz, 1); // komrek acuchy
       String srednia=(String)model.getValueAt(wiersz, 2);       
       if(nazwisko!=null&&uwagi!=null&&srednia!=null&&
        !nazwisko.equals("")&& !uwagi.equals("")
        &&!srednia.equals(""))
          {try
           {Float.parseFloat(srednia);
            Dane1 d=Dane1.Wstaw(nazwisko,uwagi, srednia);
            dane.add(d);  
            Collections.sort(dane);                                 
            wyswietl();
           }catch(NumberFormatException e)
            {JOptionPane.showMessageDialog(this,
                "Wprowadz poprawn redni");}
          }
       }   
   }
 }  
        
       
class Okno extends JFrame implements ActionListener
{
   //skadniki interfesju graficznego uytkownika
   Panel  panel;     
   JButton osobaOK ;
   JButton repaintOK ;
  
   public Okno(Vector <Dane1>dane)
   {super("Dane osb");
    setSize(350,250);
    osobaOK=new JButton("Osoba OK");
    osobaOK.addActionListener(this);
    repaintOK=new JButton("Repaint OK");
    repaintOK.addActionListener(this);
    setDefaultLookAndFeelDecorated(true);
    setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    panel = new Panel(dane);
    panel.setOpaque(true); 
    panel.add(osobaOK);
    panel.add(repaintOK);
    setContentPane(panel);
    setVisible(true);
  }
   

   
   public void actionPerformed(ActionEvent evt)
    { Object zrodlo=evt.getSource();
      if (zrodlo==osobaOK)  
         panel.obslugaactionPerformed();
      else 
      if (zrodlo==repaintOK)
         panel.wyswietl();
          //wywoanie funkcji odwieajcej zawarto tabeli
      repaint(); //i pokazanie jej na ekranie              
     }
}
 public class DaneOsob
  {    Vector<Dane1> dane=new Vector<Dane1>(5,5); 
     
     static  public void main(String arg[])
        {  DaneOsob baza = new  DaneOsob();
           Okno okno = new Okno(baza.dane); 
        }
}

